#include "stdafx.h"
#include "EcmDat.h"

CEcmDat::CEcmDat()
{
	m_handle = CreateEvent(NULL, FALSE, FALSE, NULL);
	m_exit = FALSE;
}

CEcmDat::~CEcmDat()
{
	CloseHandle(m_handle);
}

void CEcmDat::set(BYTE* data,ULONG size)
{
	const BYTE ecm_cmd[4] = {0x90, 0x34, 0x00, 0x00};
	ULONG i,j;
	ECM_DAT ecm;

	m_buf.set(data,size);
	size = m_buf.size();
	if(size < 8) return;

	BYTE* m = new BYTE[size];
	m_buf.get(m,size);

	for(i = 3; i < size - 4; i++)	// ECMT[`
		if(memcmp(m + i, ecm_cmd, 4) == 0) break;

	if(i == size - 4){			// ECMȂꍇ
		m_buf.flash(i-3);		// ȂƂ܂Ń|C^ړ
		goto END;
	}

	for(i = i - 3; i+m[i+2]+3 < size ;){
		if(memcmp(m+i+3, ecm_cmd, 4) == 0){
			{		// ECM `FbN
				ULONG chk;
				chk = i;
				if(m[chk+2]+4 >= (int)size) break;
				chk += m[chk+2]+4;
				if(m[chk+2]+4+chk >= (int)size) break;
			}

			ecm.magic = 0;

			TRACE0("Store ecm: ");
			DebugDump((BYTE*)&m[i+8],m[i+7]+1);
			for(j = 0; j < m[i+7]; j++)
				ecm.magic ^= m[i+8+j] << (8*(j%4));

			i += m[i+2]+4;
			memcpy(ecm.key,m+i+3,25);

			TRACE0("Store key: ");
			DebugDump(ecm.key,25);
			ecm.time = GetTickCount();

			m_q.push_front( ecm );
			SetEvent(m_handle);

		}
		i += m[i+2]+4;
	}

	m_buf.flash(i);		// ͂Ƃ܂Ń|C^ړ

END:
	delete [] m;
}

ECM_DAT CEcmDat::get(ULONG magic)
{
	ECM_DAT ret;

	int i,size;
RETRY:
	ZeroMemory((void*)&ret,sizeof(ret));
	size = (int)m_q.size();

	for(i = 0; i < size ; i ++){
		if(m_q[i].magic == magic){
			TRACE1("Hit Ptr:%d\n",i);
			ret = m_q[i];
			break;
		}
	}
	if(i == size){
		ResetEvent(m_handle);
		LOG_OUT("Warning : ECM Que Empty\n");
		TRACE0("Warning : ECM Que Empty\n");
		WaitForSingleObject(m_handle, INFINITE);
		if(	m_exit == TRUE) return ret;
		goto RETRY;
	}


	if(m_q.size() > 50 ){
//		ret = m_q.front();
		m_q.pop_back();
	}

	return ret;
	
}

void CEcmDat::GetKsKey(BYTE* cmd,ULONG len,BYTE* ret)
{
	ULONG magic=0;
	ECM_DAT ecm;

	int j;

	TRACE0("	Get ecm: ");
	DebugDump((BYTE*)cmd,len);

	for(j = 0; j < (int)len-5 ; j++){
		magic ^= cmd[j+5] << (8*(j%4));
	}

	ecm = get(magic);

	TRACE0("		Hit ecm: ");
	DebugDump(ecm.key,25);
	memcpy(ret,ecm.key,25);

	if(m_diagmode){
		LOG_OUT("ECM Mergin : %d ms\n",GetTickCount() - ecm.time);
	}
	
	return;
}

void CEcmDat::exit(void)
{
	m_exit = TRUE;
	SetEvent(m_handle);
}
